module Names(FMap,idf,appf,appf',
             VarId,TypeId,Name,NameSupply,St(..),Rename,suppex,supply,
             freshVar,freshType,evalName,localName,
             renaming,local,
             newname,rename,newtyp,retype,
             NameT,freshVarT,forkName)
where

import Maybe
import List
import Utils
import State

type VarId = String
type TypeId = String
type NameSupply = ([VarId],[TypeId])
type Name b = St NameSupply b

supply :: NameSupply
supply = (names,names)
         where names  = tail (concat (iterate next [[]]))
                        where next xs = [a:x | a<- ['a'..'z'], x<-xs]

suppex :: [VarId] -> [TypeId] -> NameSupply -> NameSupply
suppex xs ts (nxs,nts) = (nxs \\ xs, nts \\ ts)

freshVar :: Name VarId 
freshVar = St (\(vs,ts) -> (head vs, (tail vs,ts)))

freshType :: Name TypeId 
freshType = St (\(vs,ts) -> (head ts, (vs,tail ts)))

evalName :: NameSupply -> Name a -> a
evalName = eval

-- apply tr to the name supply before evaluating f, then revert to original
-- supply
localName :: (NameSupply -> NameSupply) -> Name a -> Name a
localName tr (St f) = St g
                     where g n@(vs,ts) = (r,(vs,ts))
                              where (r,_) = f (tr n)

-- Renaming

type Renaming = (NameSupply,FMap VarId VarId,FMap TypeId TypeId)
type Rename a = St Renaming a

renaming :: (a -> Rename a) -> (a -> Name a) 
renaming f x = St h 
               where h a = (b,fromRenaming r)
                          where (b,r) = appl (f x) (toRenaming a)

fromRenaming :: Renaming -> NameSupply
fromRenaming (n,_,_) = n 

toRenaming ::  NameSupply -> Renaming
toRenaming ns = (ns,[],[])

local :: Rename a -> Rename a
local (St h) =  St g
                where g n@((xs,ts),f,g) = (r,((xs',ts'),f,g))
                                          where (r,((xs',ts'),_,_)) = h n

newname :: VarId -> Rename VarId
newname x = St (\((y:ys,ts),f,g) ->  (y,((ys,ts),(x,y):f,g)))

rename :: VarId -> Rename VarId
rename x = St (\ r@(xs,f,g) ->  (appf' f x x,r))

newtyp :: TypeId -> Rename TypeId
newtyp x = St (\((ys,t:ts),f,g) ->  (t,((ys,ts),f,(x,t):g)))

retype :: TypeId -> Rename TypeId
retype x = St (\ r@(xs,f,g) ->  (appf' g x x,r))


-- NameT

type NameT m b = StT NameSupply m b

freshVarT :: Monad m => NameT m VarId 
freshVarT = StT (\(vs,ts) -> return (head vs, (tail vs,ts)))

forkName :: NameT [] b -> Name [b]

forkName (StT f) = St g
         where g s = let results = f s in 
                      (map fst results, merge s (map snd results))
               merge s xs = if null xs then s else foldr1 combine xs
               combine (varids,typeids) (varids',typeids') 
                     = (comb varids varids',comb typeids typeids')
               comb (id:ids) (id':ids') = if id<id' then id':ids' else id:ids

